searchNodes=[{"doc":"This is the main Exsm module. It keeps most of the Exsm logics, it&#39;s the module that will be imported with use on the module responsible for the state machine. Declare the states as an argument when importing Exsm on the module that will control your states transitions. Exsm expects a Keyword as argument with two keys states and transitions. Parameters opts: A Keyword including states and transitions. states: A List of Strings representing each state. transitions: A Map for each state and it allowed next state(s). Example defmodule YourProject.UserStateMachine do use Exsm, # The first state declared will be considered # the intial state states: [&quot;created&quot;, &quot;partial&quot;, &quot;complete&quot;], transitions: %{ &quot;created&quot; =&gt; [&quot;partial&quot;, &quot;complete&quot;], &quot;partial&quot; =&gt; &quot;completed&quot; } end","ref":"Exsm.html","title":"Exsm","type":"module"},{"doc":"Main macro function that will be executed upon the load of the module using it. It basically stores the states and transitions. It expects a Keyword as argument with two keys states and transitions. states: A List of Strings representing each state. transitions: A Map for each state and it allowed next state(s). P.S. The first state declared will be considered the intial state","ref":"Exsm.html#__using__/1","title":"Exsm.__using__/1","type":"macro"},{"doc":"Triggers the transition of a struct to a new state, accordinly to a specific state machine module, if it passes any existing guard functions. It also runs any before or after callbacks and returns a tuple with {:ok, struct}, or {:error, &quot;reason&quot;}. Parameters struct: The struct you want to transit to another state. state_machine_module: The module that holds the state machine logic, where Exsm as imported. next_state: String of the next state you want to transition to. Examples Exsm.transition_to(%User{state: :partial}, UserStateMachine, :completed) {:ok, %User{state: :completed}}","ref":"Exsm.html#transition_to/3","title":"Exsm.transition_to/3","type":"function"},{"doc":"Exsm module responsible for control transitions, guard functions and callbacks (before and after). This is meant to be for internal use only.","ref":"Exsm.Transition.html","title":"Exsm.Transition","type":"module"},{"doc":"Function responsible to run all after_transitions callbacks or fallback to a boilerplate behaviour. This is meant to be for internal use only.","ref":"Exsm.Transition.html#after_callbacks/3","title":"Exsm.Transition.after_callbacks/3","type":"function"},{"doc":"Function responsible to run all before_transitions callbacks or fallback to a boilerplate behaviour. This is meant to be for internal use only.","ref":"Exsm.Transition.html#before_callbacks/3","title":"Exsm.Transition.before_callbacks/3","type":"function"},{"doc":"Function responsible for checking if the transition from a state to another was specifically declared. This is meant to be for internal use only.","ref":"Exsm.Transition.html#declared_transition?/3","title":"Exsm.Transition.declared_transition?/3","type":"function"},{"doc":"Default guard transition fallback to make sure all transitions are permitted unless another existing guard condition exists. This is meant to be for internal use only.","ref":"Exsm.Transition.html#guarded_transition?/3","title":"Exsm.Transition.guarded_transition?/3","type":"function"},{"doc":"Function resposible for triggering transitions persistence. This is meant to be for internal use only.","ref":"Exsm.Transition.html#log_transition/3","title":"Exsm.Transition.log_transition/3","type":"function"},{"doc":"This function will try to trigger persistence, if declared, to the struct changing state. This is meant to be for internal use only.","ref":"Exsm.Transition.html#persist_struct/3","title":"Exsm.Transition.persist_struct/3","type":"function"},{"doc":"This is a GenServer that controls the transitions for a struct using a set of helper functions from Exsm.Transition It&#39;s meant to be run by a supervisor.","ref":"Exsm.Transitions.html","title":"Exsm.Transitions","type":"module"},{"doc":"Exsm TODO: Add description","ref":"readme.html","title":"Exsm","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding exsm to your list of dependencies in mix.exs: def deps do [ {:exsm, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/exsm.","ref":"readme.html#installation","title":"Exsm - Installation","type":"extras"},{"doc":"Machinery - State machine thin layer for structs","ref":"readme.html#credits","title":"Exsm - Credits","type":"extras"}]